#ifndef EFL_GENERATED_ELM_APP_SERVER_VIEW_HH
#define EFL_GENERATED_ELM_APP_SERVER_VIEW_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "elm_app_server_view.eo.h"
}

#include "eo_base.eo.hh"
#include <evas_object.eo.hh>
#include <string>

struct elm_app_server_view;

/// @cond EO_CXX_ABSTRACT
namespace eo_cxx {

struct elm_app_server_view
{
   void pause() const;

   void resume() const;

   void shallow() const;

   void close() const;

   short progress_get() const;

   void progress_set(short progress_) const;

   int new_events_get() const;

   void new_events_set(int events_) const;

   ::efl::eina::string_view icon_get() const;

   void icon_set(::efl::eina::string_view icon_) const;

   ::efl::eina::optional< ::efl::eina::string_view > title_get() const;

   void title_set(::efl::eina::optional< ::efl::eina::string_view > title_) const;

   void window_set(::evas::object win_) const;

   ::efl::eina::string_view id_get() const;

   void id_set(::efl::eina::string_view ret_) const;

   Elm_App_View_State state_get() const;

   ::efl::eina::string_view path_get() const;

   void pixels_get(unsigned int* w_, unsigned int* h_, Eina_Bool* has_alpha_, const unsigned char ** pixels_) const;

   void pixels_set(unsigned int w_, unsigned int h_, bool has_alpha_, const unsigned char * pixels_) const;

   template <typename F>
   ::efl::eo::signal_connection
   callback_resumed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_RESUMED, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_RESUMED );
   }

   template <typename T>
   void
   callback_resumed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_RESUMED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_paused_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_PAUSED, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_PAUSED );
   }

   template <typename T>
   void
   callback_paused_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_PAUSED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_closed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_CLOSED, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_CLOSED );
   }

   template <typename T>
   void
   callback_closed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_CLOSED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_shallow_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_SHALLOW, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_SHALLOW );
   }

   template <typename T>
   void
   callback_shallow_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_SHALLOW, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_save_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_SAVE, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_SAVE );
   }

   template <typename T>
   void
   callback_save_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_SAVE, info));
   }



   static Eo_Class const* _eo_class()
   {
      return(ELM_APP_SERVER_VIEW_CLASS);
   }

   operator ::elm_app_server_view() const;
   operator ::elm_app_server_view&();
   operator ::elm_app_server_view const&() const;

   /// @cond LOCAL
   template <typename D>
   struct address_of
   {
      operator ::elm_app_server_view*() const { return static_cast<::elm_app_server_view*>(static_cast<D const*>(this)->p); }
      operator ::elm_app_server_view const*() const { return static_cast<::elm_app_server_view const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::elm_app_server_view const*() const { return static_cast<::elm_app_server_view const*>(static_cast<D const*>(this)->p); }
   };
   /// @endcond

private:

   /// @internal
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}
/// @endcond

/// @brief Class elm_app_server_view
struct elm_app_server_view
      : ::efl::eo::concrete
      , EO_CXX_INHERIT(eo::base)
{
   //@{
   /**
      @brief Constructs a new elm_app_server_view object.

      Constructs a new elm_app_server_view object. If you want this object to be a child
      of another Eo object, use an @ref efl::eo::parent expression, like the example.

      Example:
      @code
      elm_app_server_view my_elm_app_server_view(efl::eo::parent = parent_object);
      @endcode

      @see elm_app_server_view(Eo* eo)
   */
   explicit elm_app_server_view(::efl::eo::parent_type _p)
      : elm_app_server_view(_ctors_call(_p))
   {}

   explicit elm_app_server_view()
      : elm_app_server_view(_ctors_call(::efl::eo::parent = nullptr))
   {}
   //@}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit elm_app_server_view(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit elm_app_server_view(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   elm_app_server_view(elm_app_server_view const& other)
      : elm_app_server_view(eo_ref(other._eo_ptr()))
   {}

   ~elm_app_server_view() {}

   void pause() const;

   void resume() const;

   void shallow() const;

   void close() const;

   short progress_get() const;

   void progress_set(short progress_) const;

   int new_events_get() const;

   void new_events_set(int events_) const;

   ::efl::eina::string_view icon_get() const;

   void icon_set(::efl::eina::string_view icon_) const;

   ::efl::eina::optional< ::efl::eina::string_view > title_get() const;

   void title_set(::efl::eina::optional< ::efl::eina::string_view > title_) const;

   void window_set(::evas::object win_) const;

   ::efl::eina::string_view id_get() const;

   void id_set(::efl::eina::string_view ret_) const;

   Elm_App_View_State state_get() const;

   ::efl::eina::string_view path_get() const;

   void pixels_get(unsigned int* w_, unsigned int* h_, Eina_Bool* has_alpha_, const unsigned char ** pixels_) const;

   void pixels_set(unsigned int w_, unsigned int h_, bool has_alpha_, const unsigned char * pixels_) const;

   template <typename F>
   ::efl::eo::signal_connection
   callback_callback_add_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_CALLBACK_ADD, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         EO_BASE_EVENT_CALLBACK_ADD );
   }

   template <typename T>
   void
   callback_callback_add_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_CALLBACK_ADD, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_callback_del_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_CALLBACK_DEL, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         EO_BASE_EVENT_CALLBACK_DEL );
   }

   template <typename T>
   void
   callback_callback_del_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_CALLBACK_DEL, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_closed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_CLOSED, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_CLOSED );
   }

   template <typename T>
   void
   callback_closed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_CLOSED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_del_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (EO_BASE_EVENT_DEL, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         EO_BASE_EVENT_DEL );
   }

   template <typename T>
   void
   callback_del_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (EO_BASE_EVENT_DEL, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_paused_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_PAUSED, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_PAUSED );
   }

   template <typename T>
   void
   callback_paused_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_PAUSED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_resumed_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_RESUMED, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_RESUMED );
   }

   template <typename T>
   void
   callback_resumed_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_RESUMED, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_save_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_SAVE, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_SAVE );
   }

   template <typename T>
   void
   callback_save_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_SAVE, info));
   }

   template <typename F>
   ::efl::eo::signal_connection
   callback_shallow_add(F && callback_,
                        ::efl::eo::callback_priority priority_ =
                        ::efl::eo::callback_priorities::default_)
   {
      typedef typename std::remove_reference<F>::type function_type;
      ::std::unique_ptr<function_type> f ( new function_type(std::forward<F>(callback_)) );
      eo_do(_concrete_eo_ptr(),
            eo_event_callback_priority_add
            (ELM_APP_SERVER_VIEW_EVENT_SHALLOW, priority_,
            &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>, f.get()));
      return ::efl::eo::make_signal_connection
         (f, _concrete_eo_ptr(), &::efl::eo::_detail::event_callback<::elm_app_server_view, function_type>,
         ELM_APP_SERVER_VIEW_EVENT_SHALLOW );
   }

   template <typename T>
   void
   callback_shallow_call(T* info)
   {
      eo_do(_concrete_eo_ptr(), eo_event_callback_call
            (ELM_APP_SERVER_VIEW_EVENT_SHALLOW, info));
   }



   static Eo_Class const* _eo_class()
   {
      return(ELM_APP_SERVER_VIEW_CLASS);
   }

   /// @cond LOCAL
   struct address_of
      : ::eo_cxx::elm_app_server_view::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::elm_app_server_view* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::elm_app_server_view::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::elm_app_server_view const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

   /// @endcond

private:

   /// @internal
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(ELM_APP_SERVER_VIEW_CLASS, _p._eo_raw);

      return _ret_eo;
   }

   /// @internal
   Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::elm_app_server_view) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::elm_app_server_view>::value, "");


#include "elm_app_server_view.eo.impl.hh"

#endif // EFL_GENERATED_ELM_APP_SERVER_VIEW_HH

